using System;
using System.Collections.Generic;
using System.Text;
using CommandLine;

namespace DTLoggedExec
{
    
    class ApplicationArguments
    {
        [Argument(ArgumentType.AtMostOnce, ShortName = "SP", HelpText = "Show params supported by the Package")]
        public bool ShowParams = false;

        [Argument(ArgumentType.AtMostOnce, ShortName = "LE", HelpText = "Events to log (comma separated value list)", DefaultValue = "E")]
        public string LogEvents = null;

        [Argument(ArgumentType.Multiple, ShortName="Conf", HelpText = "Configuration file to use")]
        public string[] ConfigFile = null;

        [Argument(ArgumentType.AtMostOnce, ShortName = "DT", HelpText = "PackagePath")]
        public string DTS = null;

        [Argument(ArgumentType.AtMostOnce, ShortName = "De", HelpText = "Password")]
        public string Decrypt = null;

        [Argument(ArgumentType.AtMostOnce, ShortName = "F", HelpText = "FileSpec")]
        public string FILE = null;

        [Argument(ArgumentType.AtMostOnce, ShortName = "P", HelpText = "Password")]
        public string Password = null;

        [Argument(ArgumentType.Multiple, HelpText = "PropertyPath;Value")]
        public string[] Set = null;

        [Argument(ArgumentType.Multiple, HelpText = "ParamName;Value")]
        public string[] Param = null;

        [Argument(ArgumentType.AtMostOnce, ShortName = "AC", HelpText = "SQL Server Instance, Database and Table where SSIS Configurations are stored. Ex: localhost\\R2;SSISConfig;dbo.ssis_configurations")]
        public string AutoConfigure = null;

        [Argument(ArgumentType.AtMostOnce, ShortName = "Ser", HelpText = "Server")]
        public string Server = null;

        [Argument(ArgumentType.AtMostOnce, ShortName = "SQ", HelpText = "PackagePath")]
        public string SQL = null;

        [Argument(ArgumentType.AtMostOnce, ShortName = "U", HelpText = "User name")]
        public string User = null;

        [Argument(ArgumentType.AtMostOnce, ShortName = "LP", HelpText = "Log Provider class name", DefaultValue = "DTLoggedExec.LogProviders.ConsoleLogProvider")]
        public string LogProvider = null;

        [Argument(ArgumentType.AtMostOnce, ShortName = "PDF", HelpText = "Activate DataFlow profiling (DEPRECATED)", DefaultValue = false)]
        public bool ProfileDataFlow = false;

        [Argument(ArgumentType.AtMostOnce, ShortName = "PP", HelpText = "The folder where dataflow profiling data will be saved (DEPRECATED)")]
        public string ProfilePath = null;

        [Argument(ArgumentType.AtMostOnce, ShortName = "PFN", HelpText = "The file name used to store profiling data. Available token: {date} and {time} to put date and time in filename. (DEPRECATED)")]
        public string ProfileFileName = null;

        [Argument(ArgumentType.AtMostOnce, ShortName = "PDFN", HelpText = "Activate DataFlow profiling and store profiled data into specifed file. Available token: {date} and {time} to put date and time in file name.")]
        public string ProfileDataFlowFileName = null;

        [Argument(ArgumentType.AtMostOnce, ShortName = "LPA", HelpText = "Configuration options for used Log Provider")]
        public string LogProviderArguments = null;
    }
}
